.module Multithread

	jp SkipThisInclude
	
	MaxThreads = 32
	
	.var uword[MaxThreads], ThreadStores

	.var 16, MasterThreadRegisters
	
	Init
		; Initialise the multithreading library
	
		di
		im 1
		
		; Load interrupt handler
		
		ld hl,Interrupt.InterruptCode
		ld de,Interrupt.Location
		ld bc,Interrupt.InterruptCodeEnd - Interrupt.InterruptCode
		ldir
	
		ld hl,Interrupt.Table
		ld a,Interrupt.Base
		ld (hl),a
		ld d,h \ ld e,l
		inc de
		ld bc,256
		ldir
	
		ld a,Interrupt.Table >> 8
		ld i,a
		
		; Clear thread stores
		ld hl,ThreadStores
		ld (Interrupt.CurrentThreadStore),hl
		ld de,ThreadStores+1
		ld (hl),0
		ld bc,sizeof(ThreadStores)-1
		ldir
		
		ld hl,MasterThreadRegisters
		ld (ThreadStores),hl
		ld hl,MasterThreadRegisters+16
		ld (Interrupt.StoreOldRegisters),hl
		
		im 2
		ei
		halt
		ret
		
	End
		di
		im 1
		ei
		ret

	
	.module Thread
	.include "Library/NewThread.asm"
	.include "Library/EndThread.asm"
	.endmodule

	.include "Library/Interrupt.asm"
	SkipThisInclude
.endmodule